C++ Tutorial Index

C++ Tutorial C++ History C++ Installation C++ First Program C++ cin and cout C++ Data type C++ Variable C++ operator C++ Keywords

C++ Control Statements

C++ If C++ Nested if C++ If-else C++ If-else-if C++ Switch C++ Break C++ Continue C++ Goto C++ For loop C++ While loop C++ Do while loop

C++ Functions

C++ Call by Value C++ Call by Reference C++ Recursion Function C++ Inline function C++ Friend function

C++ Arrays

Single dimension array Two dimension array

C++ Strings

C++ Strings

C++ Inheritance

C++ Inheritance Single level Inheritance Multilevel Inheritance Multiple Inheritance Hierarchical Inheritance Hybrid Inheritance

C++ Polymorphism

C++ Polymorphism C++ Overloading C++ Overriding C++ Virtual Function

C++ Pointers

C++ Pointers C++ this pointer

C++ Exception Handling

C++ Exception Handling

C++ Constructors

C++ Constructors Default Constructor Parameterize Constructor Copy constructor Constructor Overloading Destructor

C++ File Handling

C++ File Handling C++ Writing to file C++ Reading file C++ Close file

Miscellaneous

C Vs C++ C++ Comments C++ Data Abstraction C++ Identifier C++ Memory Management C++ Storage Classes C++ Void Pointer C++ Array To Function C++ Expressions C++ Features C++ Interfaces C++ Encapsulation std::min in C++ External merge sort in C++ Remove duplicates from sorted array in C++ Precision of floating point numbers Using these functions floor(), ceil(), trunc(), round() and setprecision() in C++ C++ References C++ Friend Functions C++ Mutable keyword Unary Operators in C++ Initialize Array of objects with parameterized constructors in C++ Differences between #define & const in C/C++ C++ Program to Implement Shell Sort C++ Program to Implement Merge Sort Storage Classes in C Vector resize() in C++ Passing by Reference Vs. Passing by the pointer in C++ Free vs delete() in C++ goto statement in C and C++ C++ program to read string using cin.getline() C++ String Concatenation Heap Sort in C++ Swap numbers in C++ Input Iterators in C++ Fibonacci Series in C++ C ++ Program: Alphabet Triangle and Number Triangle C++ Program: Matrix Multiplication C++ Program to Print Fibonacci Triangle Stack in C++ Maps in C++ Queue in C++ C++ Bitset C++ Algorithms Priority Queue in C++ C++ Multimap C++ Deque Function Pointer in C++ Sizeof() Operators in C++ C++ array of Pointers free() Vs delete in C Timsort Implementation Using C++ CPP Templates C++ Aggregation C++ Enumeration C++ Math Functions C++ Object Class C++ Queue Initialize Vector in C++ Vector in C++ C++ STL Components Function overloading in C++ C++ Maximum Index Problem C++ find missing in the second array C++ Program to find the product array puzzle C++ Program To Find Largest Subarray With 0 Sum C++ Program To Move All Zeros To The End Of The Array C++ Program to find the element that occurs once C++ Program to find the largest number formed from an array Constructor Vs Destructor C++ Namespaces C++ OOPs Concept C++ Static C++ Structs C++ Try-Catch C++ User Defined Exceptions C++ Virtual Destructor C++ vs C# Malloc() and new in C++ Palindrome Number Program in C++ Snake Code in C++ Splitting a string in C++ Structure Vs Class in C++ Virtual Function Vs Pure Virtual Function C++ Bidirectional Iterators C++ Forward Iterators C++ Iterators C++ Output Iterators C++ Range-based For Loop Converting string into integer in C++ LCM Program in C++ Type conversion in C++ Add two numbers using the function in C++ Advantage and disadvantage friend function C++ Armstrong Number Program in C++ ATM machine program in C++ using functions Binary to Decimal in C++ Bit Manipulation in C++ C++ Constructor C++ Dijkstra Algorithm Using the Priority Queue C++ int into String C++ Signal Handling Decimal to Binary in C++ Decimal to Hexadecimal in C++ Decimal to Octal in C++ Factorial Program in C++ Function in C++ Hexadecimal to Decimal in C++ Octal to Decimal in C++ Reverse a Number in C++ Structure Vs Class in C++ C++ Forward Iterators C++ Output Iterators C++ Prime number program Char Array to String in C++ Constructor Overloading in C++ Default arguments in C++ Different Ways to Compare Strings in C++ Dynamic Binding in C++ Program to convert infix to postfix expression in C++ SET Data Structure in C++ Upcasting and Downcasting in C++ Reverse an Array in C++ Fast Input and Output in C++ Delete Operator in C++ Copy elision in C++ C++ Date and Time C++ Bitwise XOR Operator Array of sets in C++ Binary Operator Overloading in C++ Binary Search in C++ Implementing the sets without C++ STL containers Scope Resolution Operator in C++ Smart pointers in C++ Types of polymorphism in C++ Exception Handling in C++ vs Java Const Keyword in C++ Type Casting in C++ Static keyword in C++ vs Java Inheritance in C++ vs Java How to concatenate two strings in C++ Programs to Print Pyramid Patterns in C++ swap() function in C++ Structure of C++ Program Stringstream in C++ and its applications rand() and srand() in C / C++ C++ Ternary Operator C++ Scope of Variables While Loop Examples in C++ Star pattern in C++ using For Loops For Loop Examples in C++ Do-While Loop Examples in C++ Top 5 IDEs for C++ That You Should Try Once Assertions in C/C++ C++ Convert Int to String Continue in C++ While loop Diamond Pattern in C++ using For Loop How to Reverse a String in C++ using Do-While Loop How to Reverse a String in C++ using For Loop How to Reverse a String in C++ using While Loop Infinite loop in C++ Loops in C++

C++ User Defined Exceptions

Overriding and inheriting exception class capabilities may be used to define the new exception. Exception handling can also be used with classes. We may also make an exception for user-defined class types. Within the try block, we may write to throw an exception of type demo_exception class.

throw demo_exception();

Example:

#include <iostream>
#include <bits/stdc++.h>
#include <stdlib>
using namespace std; 
class demo_exception {
};


int main()
{	try {
		throw demo_exception();
	}
	catch (demo_exception d) {
		cout << "Caught exception of demo class \n";
	}
return 0;
}

OUTPUT:

Caught exception of demo_exception class
…………………………………………………………………
Process executed in 3213.33 seconds
Pres any key to continue.

Explanation:

We declared an empty class in the program. We toss an object of type demo class in the try block. The try block catches and shows the item.

Let's look at a basic user-defined exception example that uses the std::exception class to specify the exception.

#include <iostream>  
#include <exception> 
#include <bits/stdc++.h>
#include <stdlib> 
using namespace std;  
class My_exception : public exception{  
    public:  
        const char * what() const throw()  
        {  
            return "Attempted to divide by zero!\n";  
        }  
};  
int main()  
{  
    try  
    {  
        int i, j;  
        cout << "enter the two numbers : \n";  
        cin >> i >> j;  
        if (y == 0)  
        {  
            My_exception k;  
            throw k;  
        }  
        else  
        {  
            cout << "i / j = " << i/j << endl;  
        }  
    }  
    catch(exception& e)  
    {  
        cout << e.what();  
    }
return 0;  
}  

OUTPUT:

enter the two numbers :
50
5
x / y = 10  
……………………………………
Process executed in 121.2 seconds
Press any key to continue.

Explanation:

What() is a public function given by the exception class in the example above. It's used to find out what caused an exception.

Let us see an example of two-class program to implement exception handling:

#include <iostream>
#include <bits/stdc++.h>
#include <stdlib>
#include <exception>
using namespace std; 
class demo_exception1 {
};
class demo_exception2 {
};
int main()
{
	for (int i = 1; i <= 2; i++) {
		try {
			if (i == 1)
				throw demo_exception1();


			else if (i == 2)
				throw demo_exception2();
		}
		catch (demo_exception1 d1) {
			cout << "Caught exception of demo_exception1 class \n";
		}
		catch (demo_exception2 d2) {
			cout << "Caught exception of demo_exception2 class \n";
		}
	}
}

OUTPUT:

Caught exception of demo_exception1 class
Caught exception of demo_exception2 class
……………………………………………………………………
Process executed in 1112. Seconds
Press any key to continue.

Handling exceptions via inheritance

Exception handling can also be accomplished using inheritance. In the case of inheritance, the first catch block catches the object thrown by the derived class.

Example:

#include <iostream>
#include <bits/stdc++.h>
#include <stdlib>
#include <exception>
using namespace std; 
class demo_exception1 {
};
class demo_exception2 : public demo_exception1 {
};
int main()
{
	for (int a = 1; a <= 2; a++) {
		try {
			if (a == 1)
				throw demo_exeception1();


			else if (a == 2)
				throw demo_exception2();
		}
		catch (demo_exception1 d1) {
			cout << "Caught exception of demo_exception1 class \n";
		}
		catch (demo_exception2 d2) {
			cout << "Caught exception of demo_exception2 class \n";
		}
	}
}

OUTPUT:

Caught exception of demo_exception1 class
Caught exception of demo_exception1 class
…………………………………………………………………..
Process executed in 0.122 seconds 
Press any key to continue.

Explanation:

The program is similar to the last one, only demo_exception2 is now a derived class of demo_exception1. It's worth noting that the demo_exception1 catch block is written first. Demo_exception1 is the base class for demo_exception2, therefore any object thrown by demo_exception2 will be dealt with by the first catch block. As a result, the output is as indicated.

Constructor-based exception handling

Constructor-based exception handling is also possible. Although the function Object () { [native code] } cannot return any value, the try and catch block can.

Example:

#include <iostream>
#include <stdlib>
#include <bits/stdc++.h>
using namespace std; 
class demo_exception {
	int number; 
public:
	demo_exception(int i)
	{
	try {
		if (i == 0)
			// catch block would be called
			throw "Zero not allowed ";
			number = i;
			show();
		}
		catch (const char* exptn) {
			cout << "exception caught \n ";
			cout << exptn << endl;
		}
	}
	void show()
	{
		cout << "Number = " << number << endl;
	}
};
int main()
{
	// constructor will be called
	demo_exception(0);
	cout << "Again creating object \n";
	demo_exception(1);
}

OUTPUT:

exception caught
Zero not allowed
Again creating object
Number = 1
....................
Process executed in 0.342 seconds
Press any key to continue.

Explantion:

When i equal 0, an exception is raised and the catch block is invoked. When i = 1, no exception is thrown.

Let’s look at another example of user defined exception in C++ and try to visualize it:

#include <iostream>
#include <bits/stdc++.h>
#include <tsdlib>
using namespace std;
int main()
{
int i = -1;
try {
	cout << "Inside try \n";
	if (i < 0)
	{
		throw i;
		cout << "After throw \n";
	}
}
catch (int i ) {
	cout << "exception Caught \n";
}
cout << "After catch \n";
return 0;
}

OUTPUT:

Inside try
Exception Caught
After catch

Explanation:

Lines of the try block after the throw statement are not performed when an exception is thrown. The code after the catch block is run when an exception is captured. Catch blocks are usually written at the conclusion of a sentence.



ADVERTISEMENT
ADVERTISEMENT